diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/build-support/custom-modules/ns3-platform-support.cmake ns-3.41/build-support/custom-modules/ns3-platform-support.cmake
--- ns-3.40/build-support/custom-modules/ns3-platform-support.cmake	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.41/build-support/custom-modules/ns3-platform-support.cmake	2024-02-09 14:44:07.725788800 -0800
@@ -0,0 +1,81 @@
+# Copyright (c) 2023 Universidade de Brasília
+#
+# This program is free software; you can redistribute it and/or modify it under
+# the terms of the GNU General Public License version 2 as published by the Free
+# Software Foundation;
+#
+# This program is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
+# details.
+#
+# You should have received a copy of the GNU General Public License along with
+# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
+# Place, Suite 330, Boston, MA  02111-1307 USA
+#
+# Author: Gabriel Ferreira <gabrielcarvfer@gmail.com>
+
+# This is where we check for platform specifics
+
+# WSLv1 doesn't support tap features
+if(EXISTS "/proc/version")
+  file(READ "/proc/version" CMAKE_LINUX_DISTRO)
+  string(FIND "${CMAKE_LINUX_DISTRO}" "Microsoft" res)
+  if(res EQUAL -1)
+    set(WSLv1 False)
+  else()
+    set(WSLv1 True)
+  endif()
+endif()
+
+# Set Linux flag if on Linux
+if(UNIX AND NOT APPLE)
+  set(LINUX TRUE)
+  add_definitions(-D__LINUX__)
+endif()
+
+if(APPLE)
+  add_definitions(-D__APPLE__)
+  # cmake-format: off
+    # Configure find_program to search for AppBundles only if programs are not found in PATH.
+    # This prevents Doxywizard from being launched when the Doxygen.app is installed.
+    # https://gitlab.kitware.com/cmake/cmake/-/blob/master/Modules/FindDoxygen.cmake
+    # cmake-format: on
+  set(CMAKE_FIND_APPBUNDLE "LAST")
+endif()
+
+if(WIN32)
+  set(NS3_PRECOMPILE_HEADERS OFF
+      CACHE BOOL "Precompile module headers to speed up compilation" FORCE
+  )
+
+  # For whatever reason getting M_PI and other math.h definitions from cmath
+  # requires this definition
+  # https://docs.microsoft.com/en-us/cpp/c-runtime-library/math-constants?view=vs-2019
+  add_definitions(/D_USE_MATH_DEFINES)
+endif()
+
+set(cat_command cat)
+
+if(CMAKE_XCODE_BUILD_SYSTEM)
+  set(XCODE True)
+else()
+  set(XCODE False)
+endif()
+
+if(${XCODE})
+  # Is that so hard not to break people's CI, AAPL? Why would you output the
+  # targets to a Debug/Release subfolder? Why?
+  foreach(OUTPUTCONFIG ${CMAKE_CONFIGURATION_TYPES})
+    string(TOUPPER ${OUTPUTCONFIG} OUTPUTCONFIG)
+    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG}
+        ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
+    )
+    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${OUTPUTCONFIG}
+        ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
+    )
+    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${OUTPUTCONFIG}
+        ${CMAKE_ARCHIVE_OUTPUT_DIRECTORY}
+    )
+  endforeach()
+endif()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/build-support/custom-modules/ns3-vcpkg-hunter.cmake ns-3.41/build-support/custom-modules/ns3-vcpkg-hunter.cmake
--- ns-3.40/build-support/custom-modules/ns3-vcpkg-hunter.cmake	2023-09-27 13:30:37.530838700 -0700
+++ ns-3.41/build-support/custom-modules/ns3-vcpkg-hunter.cmake	2024-02-09 14:44:07.725788800 -0800
@@ -73,7 +73,7 @@
     )
   endif()
 
-  if(${MSVC})
+  if(DEFINED MSVC)
     message(FATAL_ERROR "vcpkg: Visual Studio is unsupported")
   else()
     # Check if required packages are installed (unzip curl tar)
@@ -134,10 +134,12 @@
     execute_process(COMMAND chmod +x ${VCPKG_DIR}/${VCPKG_EXEC})
   endif()
 
+  disable_cmake_warnings()
   set(CMAKE_PREFIX_PATH
       "${VCPKG_DIR}/installed/${VCPKG_TRIPLET}/;${CMAKE_PREFIX_PATH}"
       PARENT_SCOPE
   )
+  enable_cmake_warnings()
 
   # Install packages in manifest mode
   if(EXISTS ${VCPKG_MANIFEST})
@@ -195,4 +197,6 @@
 
 if(${NS3_VCPKG})
   setup_vcpkg()
+  include_directories(${VCPKG_DIR}/installed/${VCPKG_TRIPLET}/include)
+  link_directories(${VCPKG_DIR}/installed/${VCPKG_TRIPLET}/lib)
 endif()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/build-support/macros-and-definitions.cmake ns-3.41/build-support/macros-and-definitions.cmake
--- ns-3.40/build-support/macros-and-definitions.cmake	2023-09-27 13:30:37.530838700 -0700
+++ ns-3.41/build-support/macros-and-definitions.cmake	2024-02-09 14:44:07.725788800 -0800
@@ -18,296 +18,57 @@
 # Export compile time variable setting the directory to the NS3 root folder
 add_definitions(-DPROJECT_SOURCE_PATH="${PROJECT_SOURCE_DIR}")
 
-# Set INT128 as the default option for INT64X64 and register alternative
-# implementations
-set(NS3_INT64X64 "INT128" CACHE STRING "Int64x64 implementation")
-set_property(CACHE NS3_INT64X64 PROPERTY STRINGS INT128 CAIRO DOUBLE)
-
-# Purposefully hidden options:
-
-# for ease of use, export all libraries and include directories to ns-3 module
-# consumers by default
-option(NS3_REEXPORT_THIRD_PARTY_LIBRARIES "Export all third-party libraries
-and include directories to ns-3 module consumers" ON
+# Add custom and 3rd-part cmake modules to the path
+list(APPEND CMAKE_MODULE_PATH
+     "${PROJECT_SOURCE_DIR}/build-support/custom-modules"
 )
+list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/build-support/3rd-party")
 
-# since we can't really do that safely from the CMake side
-option(NS3_ENABLE_SUDO
-       "Set executables ownership to root and enable the SUID flag" OFF
-)
+macro(disable_cmake_warnings)
+  set(CMAKE_SUPPRESS_DEVELOPER_WARNINGS 1 CACHE BOOL "" FORCE)
+endmacro()
+
+macro(enable_cmake_warnings)
+  set(CMAKE_SUPPRESS_DEVELOPER_WARNINGS 0 CACHE BOOL "" FORCE)
+endmacro()
 
-# a flag that controls some aspects related to pip packaging
-option(NS3_PIP_PACKAGING "Control aspects related to pip wheel packaging" OFF)
+# Set options that are not really meant to be changed
+include(ns3-hidden-settings)
 
 # Replace default CMake messages (logging) with custom colored messages as early
 # as possible
-include(${PROJECT_SOURCE_DIR}/build-support/3rd-party/colored-messages.cmake)
-
-# WSLv1 doesn't support tap features
-if(EXISTS "/proc/version")
-  file(READ "/proc/version" CMAKE_LINUX_DISTRO)
-  string(FIND "${CMAKE_LINUX_DISTRO}" "Microsoft" res)
-  if(res EQUAL -1)
-    set(WSLv1 False)
-  else()
-    set(WSLv1 True)
-  endif()
-endif()
-
-# Set Linux flag if on Linux
-if(UNIX AND NOT APPLE)
-  set(LINUX TRUE)
-  add_definitions(-D__LINUX__)
-endif()
-
-if(APPLE)
-  add_definitions(-D__APPLE__)
-  # cmake-format: off
-  # Configure find_program to search for AppBundles only if programs are not found in PATH.
-  # This prevents Doxywizard from being launched when the Doxygen.app is installed.
-  # https://gitlab.kitware.com/cmake/cmake/-/blob/master/Modules/FindDoxygen.cmake
-  # cmake-format: on
-  set(CMAKE_FIND_APPBUNDLE "LAST")
-endif()
-
-if(WIN32)
-  set(NS3_PRECOMPILE_HEADERS OFF
-      CACHE BOOL "Precompile module headers to speed up compilation" FORCE
-  )
-
-  # For whatever reason getting M_PI and other math.h definitions from cmath
-  # requires this definition
-  # https://docs.microsoft.com/en-us/cpp/c-runtime-library/math-constants?view=vs-2019
-  add_definitions(/D_USE_MATH_DEFINES)
-endif()
-
-set(cat_command cat)
-
-if(CMAKE_XCODE_BUILD_SYSTEM)
-  set(XCODE True)
-else()
-  set(XCODE False)
-endif()
-
-# Check the number of threads
-include(ProcessorCount)
-ProcessorCount(NumThreads)
-
-# Output folders
-if("${NS3_OUTPUT_DIRECTORY}" STREQUAL "")
-  message(STATUS "Using default output directory ${PROJECT_SOURCE_DIR}/build")
-  set(CMAKE_OUTPUT_DIRECTORY ${PROJECT_SOURCE_DIR}/build) # default output
-                                                          # folder
-else()
-  # Check if NS3_OUTPUT_DIRECTORY is a relative path
-  set(absolute_ns3_output_directory "${NS3_OUTPUT_DIRECTORY}")
-  if(NOT IS_ABSOLUTE ${NS3_OUTPUT_DIRECTORY})
-    set(absolute_ns3_output_directory
-        "${PROJECT_SOURCE_DIR}/${NS3_OUTPUT_DIRECTORY}"
-    )
-  endif()
-
-  # Transform backward slash into forward slash Not the best way to do it since
-  # \ is a scape thing and can be used before whitespaces
-  string(REPLACE "\\" "/" absolute_ns3_output_directory
-                 "${absolute_ns3_output_directory}"
-  )
-
-  if(NOT (EXISTS ${absolute_ns3_output_directory}))
-    message(
-      STATUS
-        "User-defined output directory \"${NS3_OUTPUT_DIRECTORY}\" doesn't exist. Trying to create it"
-    )
-    file(MAKE_DIRECTORY ${absolute_ns3_output_directory})
-    if(NOT (EXISTS ${absolute_ns3_output_directory}))
-      message(
-        FATAL_ERROR
-          "User-defined output directory \"${absolute_ns3_output_directory}\" could not be created. "
-          "Try changing the value of NS3_OUTPUT_DIRECTORY"
-      )
-    endif()
-
-    # If this directory is not inside the ns-3-dev folder, alert users tests may
-    # break
-    if(NOT ("${absolute_ns3_output_directory}" MATCHES "${PROJECT_SOURCE_DIR}"))
-      message(
-        WARNING
-          "User-defined output directory \"${absolute_ns3_output_directory}\" is outside "
-          " of the ns-3 directory ${PROJECT_SOURCE_DIR}, which will break some tests"
-      )
-    endif()
-  endif()
-  message(
-    STATUS
-      "User-defined output directory \"${absolute_ns3_output_directory}\" will be used"
-  )
-  set(CMAKE_OUTPUT_DIRECTORY ${absolute_ns3_output_directory})
-endif()
-set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_OUTPUT_DIRECTORY}/lib)
-set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_OUTPUT_DIRECTORY}/lib)
-set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_OUTPUT_DIRECTORY})
-set(CMAKE_HEADER_OUTPUT_DIRECTORY ${CMAKE_OUTPUT_DIRECTORY}/include/ns3)
-set(THIRD_PARTY_DIRECTORY ${PROJECT_SOURCE_DIR}/3rd-party)
-set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
-link_directories(${CMAKE_OUTPUT_DIRECTORY}/lib)
-file(MAKE_DIRECTORY ${CMAKE_OUTPUT_DIRECTORY})
+include(colored-messages)
 
-# Get installation folder default values for each platform and include package
-# configuration macro
+# Get installation folder default values
 include(GNUInstallDirs)
-include(build-support/custom-modules/ns3-cmake-package.cmake)
-
-# Set RPATH not too need LD_LIBRARY_PATH after installing
-set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib:$ORIGIN/:$ORIGIN/../lib")
 
-# Add the 64 suffix to the library path when manually requested with the
-# -DNS3_USE_LIB64=ON flag. May be necessary depending on the target platform.
-# This is used to properly build the manylinux pip wheel.
-if(${NS3_USE_LIB64})
-  link_directories(${CMAKE_OUTPUT_DIRECTORY}/lib64)
-  set(CMAKE_INSTALL_RPATH
-      "${CMAKE_INSTALL_RPATH}:${CMAKE_INSTALL_PREFIX}/lib64:$ORIGIN/:$ORIGIN/../lib64"
-  )
-endif()
+# Define output directories
+include(ns3-output-directory)
 
-# cmake-format: off
-# You are a wizard, Harry!
-# source: https://gitlab.kitware.com/cmake/community/-/wikis/doc/cmake/RPATH-handling
-# cmake-format: on
-set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
-
-if(${XCODE})
-  # Is that so hard not to break people's CI, AAPL? Why would you output the
-  # targets to a Debug/Release subfolder? Why?
-  foreach(OUTPUTCONFIG ${CMAKE_CONFIGURATION_TYPES})
-    string(TOUPPER ${OUTPUTCONFIG} OUTPUTCONFIG)
-    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${OUTPUTCONFIG}
-        ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
-    )
-    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${OUTPUTCONFIG}
-        ${CMAKE_LIBRARY_OUTPUT_DIRECTORY}
-    )
-    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${OUTPUTCONFIG}
-        ${CMAKE_ARCHIVE_OUTPUT_DIRECTORY}
-    )
-  endforeach()
-endif()
+# Configure packaging related settings
+include(ns3-cmake-package)
 
-# fPIC (position-independent code) and fPIE (position-independent executable)
-set(CMAKE_POSITION_INDEPENDENT_CODE ON)
+# Windows, Linux and Mac related checks
+include(ns3-platform-support)
 
-# do not create a file-level dependency with shared libraries reducing
-# unnecessary relinking
-set(CMAKE_LINK_DEPENDS_NO_SHARED TRUE)
-
-# Identify compiler and check version
-set(below_minimum_msg "compiler is below the minimum required version")
-set(CLANG FALSE)
-if("${CMAKE_CXX_COMPILER_ID}" MATCHES "AppleClang")
-  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS ${AppleClang_MinVersion})
-    message(
-      FATAL_ERROR
-        "Apple Clang ${CMAKE_CXX_COMPILER_VERSION} ${below_minimum_msg} ${AppleClang_MinVersion}"
-    )
-  endif()
-  set(CLANG TRUE)
-endif()
+# Perform compiler and linker checks
+include(ns3-compiler-and-linker-support)
 
-if((NOT CLANG) AND ("${CMAKE_CXX_COMPILER_ID}" MATCHES "Clang"))
-  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS ${Clang_MinVersion})
-    message(
-      FATAL_ERROR
-        "Clang ${CMAKE_CXX_COMPILER_VERSION} ${below_minimum_msg} ${Clang_MinVersion}"
-    )
-  endif()
-  set(CLANG TRUE)
-endif()
+# Include CMake file with common find_program HINTS
+include(find-program-hints)
 
-if(CLANG)
-  if(${NS3_COLORED_OUTPUT} OR "$ENV{CLICOLOR}")
-    add_definitions(-fcolor-diagnostics) # colorize clang++ output
-  endif()
-endif()
+# Custom find_package alternative
+include(ns3-find-external-library)
 
-set(GCC FALSE)
-set(GCC8 FALSE)
-if("${CMAKE_CXX_COMPILER_ID}" MATCHES "GNU")
-  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS ${GNU_MinVersion})
-    message(
-      FATAL_ERROR
-        "GNU ${CMAKE_CXX_COMPILER_VERSION} ${below_minimum_msg} ${GNU_MinVersion}"
-    )
-  endif()
-  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "9.0.0")
-    # This block is used to identify if GCC8 is being used. In this case, we
-    # want to explicitly link stdc++fs, which is done in
-    # ns3-module-macros.cmake.
-    set(GCC8 TRUE)
-  endif()
-  set(GCC TRUE)
-  add_definitions(-fno-semantic-interposition)
-  if(${NS3_COLORED_OUTPUT} OR "$ENV{CLICOLOR}")
-    add_definitions(-fdiagnostics-color=always) # colorize g++ output
-  endif()
-endif()
-unset(below_minimum_msg)
+# Custom check_deps to search for packages, executables and python dependencies
+include(ns3-check-dependencies)
 
 # Set compiler options and get command to force unused function linkage (useful
 # for libraries)
-set(CXX_UNSUPPORTED_STANDARDS 98 11 14)
-set(CMAKE_CXX_STANDARD_MINIMUM 17)
+set(CXX_UNSUPPORTED_STANDARDS 98 11 14 17)
+set(CMAKE_CXX_STANDARD_MINIMUM 20)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)
-set(LIB_AS_NEEDED_PRE)
-set(LIB_AS_NEEDED_POST)
-set(STATIC_LINK_FLAGS -static -static-libstdc++ -static-libgcc)
-if(${GCC} AND NOT APPLE)
-  # using GCC
-  set(LIB_AS_NEEDED_PRE -Wl,--no-as-needed)
-  set(LIB_AS_NEEDED_POST -Wl,--as-needed)
-  set(LIB_AS_NEEDED_PRE_STATIC -Wl,--whole-archive,-Bstatic)
-  set(LIB_AS_NEEDED_POST_STATIC -Wl,--no-whole-archive)
-  set(LIB_AS_NEEDED_POST_STATIC_DYN -Wl,-Bdynamic,--no-whole-archive)
-endif()
-
-if(${CLANG} AND APPLE)
-  # using Clang set(LIB_AS_NEEDED_PRE -all_load)
-  set(LIB_AS_NEEDED_POST)
-  set(LIB_AS_NEEDED_PRE_STATIC -Wl,-all_load)
-  set(STATIC_LINK_FLAGS)
-endif()
-
-if(${NS3_FAST_LINKERS})
-  # Search for faster linkers mold and lld, and use them if available
-  mark_as_advanced(MOLD LLD)
-  find_program(MOLD mold)
-  find_program(LLD ld.lld)
-
-  # USING_FAST_LINKER will be defined if a fast linker is being used and its
-  # content will correspond to the fast linker name
-
-  # Mold support was added in GCC 12.1.0
-  if(NOT USING_FAST_LINKER
-     AND NOT (${MOLD} STREQUAL "MOLD-NOTFOUND")
-     AND LINUX
-     AND ${GCC}
-     AND (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 12.1.0)
-  )
-    set(USING_FAST_LINKER MOLD)
-    add_link_options("-fuse-ld=mold")
-  endif()
-
-  if(NOT USING_FAST_LINKER AND NOT (${LLD} STREQUAL "LLD-NOTFOUND")
-     AND (${GCC} OR ${CLANG})
-  )
-    set(USING_FAST_LINKER LLD)
-    add_link_options("-fuse-ld=lld")
-    if(WIN32)
-      # Clear unsupported linker flags on Windows
-      set(LIB_AS_NEEDED_PRE)
-    endif()
-  endif()
-endif()
 
 # Include CMake files used for compiler checks
 include(CheckIncludeFile) # Used to check a single C header at a time
@@ -315,6 +76,10 @@
 include(CheckIncludeFiles) # Used to check multiple headers at once
 include(CheckFunctionExists)
 
+# Check the number of threads
+include(ProcessorCount)
+ProcessorCount(NumThreads)
+
 macro(SUBDIRLIST result curdir)
   file(GLOB children RELATIVE ${curdir} ${curdir}/*)
   set(dirlist "")
@@ -334,16 +99,25 @@
   # clear cache variables
   unset(build_profile CACHE)
   unset(build_profile_suffix CACHE)
-  unset(lib-ns3-static-objs CACHE)
-  unset(ns3-contrib-libs CACHE)
-  unset(ns3-example-folders CACHE)
-  unset(ns3-execs CACHE)
-  unset(ns3-execs-clean CACHE)
-  unset(ns3-execs-py CACHE)
-  unset(ns3-external-libs CACHE)
-  unset(ns3-headers-to-module-map CACHE)
-  unset(ns3-libs CACHE)
-  unset(ns3-libs-tests CACHE)
+  set(lib-ns3-static-objs
+      ""
+      CACHE
+        INTERNAL
+        "list of object files from module used by NS3_STATIC and NS3_MONOLIB"
+  )
+  set(ns3-contrib-libs "" CACHE INTERNAL "list of processed contrib modules")
+  set(ns3-example-folders "" CACHE INTERNAL "list of example folders")
+  set(ns3-execs "" CACHE INTERNAL "list of c++ executables")
+  set(ns3-execs-clean "" CACHE INTERNAL "list of c++ executables")
+  set(ns3-execs-py "" CACHE INTERNAL "list of python scripts")
+  set(ns3-external-libs ""
+      CACHE INTERNAL
+            "list of non-ns libraries to link to NS3_STATIC and NS3_MONOLIB"
+  )
+  set(ns3-libs "" CACHE INTERNAL "list of processed upstream modules")
+  set(ns3-libs-tests "" CACHE INTERNAL "list of test libraries")
+  set(ns3-optional-visualizer-lib "" CACHE INTERNAL "visualizer library name")
+
   mark_as_advanced(
     build_profile
     build_profile_suffix
@@ -354,45 +128,12 @@
     ns3-execs-clean
     ns3-execs-py
     ns3-external-libs
-    ns3-headers-to-module-map
     ns3-libs
     ns3-libs-tests
+    ns3-optional-visualizer-lib
   )
 endmacro()
 
-# Include CMake file with common find_program HINTS
-include(build-support/3rd-party/find-program-hints.cmake)
-
-# function used to search for package and program dependencies than store list
-# of missing dependencies in the list whose name is stored in missing_deps
-function(check_deps package_deps program_deps missing_deps)
-  set(local_missing_deps)
-  # Search for package dependencies
-  foreach(package ${package_deps})
-    find_package(${package})
-    if(NOT ${${package}_FOUND})
-      list(APPEND local_missing_deps ${package})
-    endif()
-  endforeach()
-
-  # And for program dependencies
-  foreach(program ${program_deps})
-    # CMake likes to cache find_* to speed things up, so we can't reuse names
-    # here or it won't check other dependencies
-    string(TOUPPER ${program} upper_${program})
-    mark_as_advanced(${upper_${program}})
-    find_program(
-      ${upper_${program}} ${program} HINTS ${3RD_PARTY_FIND_PROGRAM_HINTS}
-    )
-    if("${${upper_${program}}}" STREQUAL "${upper_${program}}-NOTFOUND")
-      list(APPEND local_missing_deps ${program})
-    endif()
-  endforeach()
-
-  # Store list of missing dependencies in the parent scope
-  set(${missing_deps} ${local_missing_deps} PARENT_SCOPE)
-endfunction()
-
 # process all options passed in main cmakeLists
 macro(process_options)
   clear_global_cached_variables()
@@ -466,7 +207,7 @@
 
   # Set warning level and warning as errors
   if(${NS3_WARNINGS})
-    if(MSVC)
+    if(DEFINED MSVC)
       add_compile_options(/W3) # /W4 = -Wall + -Wextra
       if(${NS3_WARNINGS_AS_ERRORS})
         add_compile_options(/WX)
@@ -479,7 +220,7 @@
     endif()
   endif()
 
-  include(build-support/custom-modules/ns3-versioning.cmake)
+  include(ns3-versioning)
   set(ENABLE_BUILD_VERSION False)
   configure_embedded_version()
 
@@ -515,18 +256,6 @@
     if("${CLANG_TIDY}" STREQUAL "CLANG_TIDY-NOTFOUND")
       message(FATAL_ERROR "Clang-tidy was not found")
     else()
-      if((${CMAKE_VERSION} VERSION_LESS "3.12.0") AND ${NS3_CCACHE}
-         AND (NOT ("${CCACHE}" STREQUAL "CCACHE-NOTFOUND"))
-      )
-        # CMake <3.12 puts CMAKE_CXX_COMPILER_LAUNCHER in the incorrect place
-        # and CCache ends up being unable to cache anything if calling
-        # clang-tidy https://gitlab.kitware.com/cmake/cmake/-/issues/18266
-        message(
-          FATAL_ERROR
-            "The current CMake ${CMAKE_VERSION} won't ccache objects correctly when running with clang-tidy."
-            "Update CMake to at least version 3.12, or disable either ccache or clang-tidy to continue."
-        )
-      endif()
       set(CMAKE_CXX_CLANG_TIDY "${CLANG_TIDY}")
     endif()
   else()
@@ -596,12 +325,23 @@
         ${PROJECT_SOURCE_DIR}/build-support/cmake-format-modules.yaml -i
         ${MODULES_CMAKE_FILES}
     )
+    add_custom_target(
+      cmake-format-check
+      COMMAND
+        ${CMAKE_FORMAT_PROGRAM} -c
+        ${PROJECT_SOURCE_DIR}/build-support/cmake-format.yaml --check
+        ${INTERNAL_CMAKE_FILES}
+      COMMAND
+        ${CMAKE_FORMAT_PROGRAM} -c
+        ${PROJECT_SOURCE_DIR}/build-support/cmake-format-modules.yaml --check
+        ${MODULES_CMAKE_FILES}
+    )
     unset(MODULES_CMAKE_FILES)
     unset(INTERNAL_CMAKE_FILES)
   endif()
 
   # If the user has not set a CXX standard version, assume the minimum
-  if(NOT "${CMAKE_CXX_STANDARD}")
+  if(NOT (DEFINED CMAKE_CXX_STANDARD))
     set(CMAKE_CXX_STANDARD ${CMAKE_CXX_STANDARD_MINIMUM})
   endif()
 
@@ -615,14 +355,9 @@
     )
   endif()
 
-  # Honor CMAKE_CXX_STANDARD in check_cxx_source_compiles
-  # https://cmake.org/cmake/help/latest/policy/CMP0067.html
-  cmake_policy(SET CMP0066 NEW)
-  cmake_policy(SET CMP0067 NEW)
-
   # After setting the correct CXX version, we can proceed to check for compiler
   # workarounds
-  include(build-support/custom-modules/ns3-compiler-workarounds.cmake)
+  include(ns3-compiler-workarounds)
 
   if(${NS3_DES_METRICS})
     add_definitions(-DENABLE_DES_METRICS)
@@ -729,12 +464,6 @@
   # Set common include folder (./build/include, where we find ns3/core-module.h)
   include_directories(${CMAKE_OUTPUT_DIRECTORY}/include)
 
-  # find required dependencies
-  list(APPEND CMAKE_MODULE_PATH
-       "${PROJECT_SOURCE_DIR}/build-support/custom-modules"
-  )
-  list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/build-support/3rd-party")
-
   # Include our package managers
   # cmake-format: off
   # Starting with a custom cmake file that provides a Hunter-like interface to vcpkg
@@ -785,21 +514,24 @@
     # find_package(SQLite3 QUIET) # unsupported in CMake 3.10 We emulate the
     # behavior of find_package below
     find_external_library(
-      DEPENDENCY_NAME SQLite3 HEADER_NAME sqlite3.h LIBRARY_NAME sqlite3
+      DEPENDENCY_NAME SQLite3
+      HEADER_NAME sqlite3.h
+      LIBRARY_NAME sqlite3
+      OUTPUT_VARIABLE "ENABLE_SQLITE_REASON"
     )
 
     if(${SQLite3_FOUND})
       set(ENABLE_SQLITE True)
       add_definitions(-DHAVE_SQLITE3)
       include_directories(${SQLite3_INCLUDE_DIRS})
-    else()
-      message(${HIGHLIGHTED_STATUS} "SQLite was not found")
     endif()
   endif()
 
   set(ENABLE_EIGEN False)
   if(${NS3_EIGEN})
+    disable_cmake_warnings()
     find_package(Eigen3 QUIET)
+    enable_cmake_warnings()
 
     if(${EIGEN3_FOUND})
       set(ENABLE_EIGEN True)
@@ -807,34 +539,32 @@
       add_definitions(-DEIGEN_MPL2_ONLY)
       include_directories(${EIGEN3_INCLUDE_DIR})
     else()
-      message(${HIGHLIGHTED_STATUS} "Eigen was not found")
+      set(ENABLE_EIGEN_REASON "Eigen was not found")
     endif()
   endif()
 
   # GTK3 Don't search for it if you don't have it installed, as it take an
   # insane amount of time
+  set(GTK3_FOUND FALSE)
   if(${NS3_GTK3})
+    disable_cmake_warnings()
     find_package(HarfBuzz QUIET)
+    enable_cmake_warnings()
     if(NOT ${HarfBuzz_FOUND})
-      message(${HIGHLIGHTED_STATUS}
-              "Harfbuzz is required by GTK3 and was not found."
-      )
+      set(GTK3_FOUND_REASON "Harfbuzz is required by GTK3 and was not found")
     else()
-      set(CMAKE_SUPPRESS_DEVELOPER_WARNINGS 1 CACHE BOOL "")
+      disable_cmake_warnings()
       find_package(GTK3 QUIET)
-      unset(CMAKE_SUPPRESS_DEVELOPER_WARNINGS CACHE)
+      enable_cmake_warnings()
       if(NOT ${GTK3_FOUND})
-        message(${HIGHLIGHTED_STATUS}
-                "GTK3 was not found. Continuing without it."
-        )
+        set(GTK3_FOUND_REASON "GTK3 was not found")
       else()
         if(${GTK3_VERSION} VERSION_LESS 3.22)
           set(GTK3_FOUND FALSE)
-          message(${HIGHLIGHTED_STATUS}
-                  "GTK3 found with incompatible version ${GTK3_VERSION}"
+          set(GTK3_FOUND_REASON
+              "GTK3 found with incompatible version ${GTK3_VERSION}"
           )
         else()
-          message(STATUS "GTK3 was found.")
           include_directories(${GTK3_INCLUDE_DIRS} ${HarfBuzz_INCLUDE_DIRS})
         endif()
       endif()
@@ -858,11 +588,8 @@
   else()
     find_package(LibXml2 QUIET)
     if(NOT ${LIBXML2_FOUND})
-      message(${HIGHLIGHTED_STATUS}
-              "LibXML2 was not found. Continuing without it."
-      )
+      set(LIBXML2_FOUND_REASON "LibXML2 was not found")
     else()
-      message(STATUS "LibXML2 was found.")
       add_definitions(-DHAVE_LIBXML2)
       include_directories(${LIBXML2_INCLUDE_DIR})
     endif()
@@ -878,31 +605,12 @@
   set(Python3_EXECUTABLE)
   set(Python3_FOUND FALSE)
   set(Python3_INCLUDE_DIRS)
+  set(Python3_Interpreter_FOUND FALSE)
   if(${NS3_PYTHON_BINDINGS})
-    if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.12.0")
-      find_package(Python3 COMPONENTS Interpreter Development)
-    else()
-      # cmake-format: off
-      set(Python_ADDITIONAL_VERSIONS 3.6 3.7 3.8 3.9 3.10 3.11)
-      # cmake-format: on
-      find_package(PythonInterp)
-      find_package(PythonLibs)
-
-      # Move deprecated results into the FindPython3 resulting variables
-      set(Python3_Interpreter_FOUND ${PYTHONINTERP_FOUND})
-      set(Python3_Development_FOUND ${PYTHONLIBS_FOUND})
-      if(${PYTHONINTERP_FOUND})
-        set(Python3_EXECUTABLE ${PYTHON_EXECUTABLE})
-        set(Python3_FOUND TRUE)
-      endif()
-      if(${PYTHONLIBS_FOUND})
-        set(Python3_LIBRARIES ${PYTHON_LIBRARIES})
-        set(Python3_INCLUDE_DIRS ${PYTHON_INCLUDE_DIRS})
-      endif()
-    endif()
+    find_package(Python3 COMPONENTS Interpreter Development)
   else()
     # If Python was not set yet, use the version found by check_deps
-    check_deps("" "python3" python3_deps)
+    check_deps(python3_deps EXECUTABLES python3)
     if(python3_deps)
       message(FATAL_ERROR "Python3 was not found")
     else()
@@ -964,7 +672,7 @@
           "macOS silicon detected -- see issue 930"
       )
     else()
-      check_python_packages("cppyy" missing_packages)
+      check_deps(missing_packages PYTHON_PACKAGES cppyy)
       if(missing_packages)
         message(
           ${HIGHLIGHTED_STATUS}
@@ -1072,9 +780,6 @@
     else()
       set(ENABLE_VISUALIZER_REASON "Python Bindings are disabled")
     endif()
-    if(ENABLE_VISUALIZER_REASON)
-      message(${HIGHLIGHTED_STATUS} "Visualizer: ${ENABLE_VISUALIZER_REASON}")
-    endif()
   endif()
 
   if(${NS3_COVERAGE} AND (NOT ${ENABLE_TESTS} OR NOT ${ENABLE_EXAMPLES}))
@@ -1097,7 +802,7 @@
       DEPENDS all-test-targets
     )
     if(${ENABLE_EXAMPLES})
-      include(build-support/custom-modules/ns3-coverage.cmake)
+      include(ns3-coverage)
     endif()
   endif()
 
@@ -1127,10 +832,11 @@
     set(CMAKE_REQUIRED_INCLUDES ${Boost_INCLUDE_DIRS})
   endif()
 
+  set(GSL_FOUND FALSE)
   if(${NS3_GSL})
     find_package(GSL QUIET)
     if(NOT ${GSL_FOUND})
-      message(${HIGHLIGHTED_STATUS} "GSL was not found. Continuing without it.")
+      set(GSL_FOUND_REASON "GSL was not found")
     else()
       message(STATUS "GSL was found.")
       add_definitions(-DHAVE_GSL)
@@ -1142,7 +848,7 @@
 
   # First we check for doxygen dependencies
   mark_as_advanced(DOXYGEN)
-  check_deps("" "doxygen;dot;dia;python3" doxygen_docs_missing_deps)
+  check_deps(doxygen_docs_missing_deps EXECUTABLES doxygen dot dia python3)
   if(doxygen_docs_missing_deps)
     message(
       ${HIGHLIGHTED_STATUS}
@@ -1258,8 +964,8 @@
   # Check deps accepts a list of packages, list of programs and name of the
   # return variable
   check_deps(
-    "Sphinx" "epstopdf;pdflatex;latexmk;convert;dvipng"
-    sphinx_docs_missing_deps
+    sphinx_docs_missing_deps CMAKE_PACKAGES Sphinx
+    EXECUTABLES epstopdf pdflatex latexmk convert dvipng
   )
   if(sphinx_docs_missing_deps)
     message(
@@ -1435,6 +1141,7 @@
   if(APPLE OR WSLv1 OR WIN32)
     set(ENABLE_TAP OFF)
     set(ENABLE_EMU OFF)
+    set(ENABLE_FDNETDEV FALSE)
     list(REMOVE_ITEM libs_to_build fd-net-device)
     message(
       STATUS
@@ -1471,9 +1178,10 @@
     set(lib${libname}-obj ${targetname}-obj CACHE INTERNAL "")
   endforeach()
 
-  unset(optional_visualizer_lib)
   if(${ENABLE_VISUALIZER} AND (visualizer IN_LIST libs_to_build))
-    set(optional_visualizer_lib ${libvisualizer})
+    set(ns3-optional-visualizer-lib "${libvisualizer}"
+        CACHE INTERNAL "visualizer library name"
+    )
   endif()
 
   set(PRECOMPILE_HEADERS_ENABLED OFF)
